> For the complete documentation index, see [llms.txt](https://docs.tensorleap.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tensorleap.ai/tensorleap-integration/python-api/code_loader/visualizer_classes/leapgraph.md).

# LeapGraph

Used to visualize a 1D signal.

```python
import numpy.typing as npt
from code_loader.contract.enums import LeapDataType

@dataclass
class LeapGraph:
    data: npt.NDArray[np.float32]
    type: LeapDataType = LeapDataType.Graph
    x_label: Optional[str] = None
    y_label: Optional[str] = None
    x_range: Optional[Tuple[float,float]] = None
    legend: Optional[List[str]] = None
```

<table><thead><tr><th width="167.39065467110788">Args</th><th></th></tr></thead><tbody><tr><td><code>data</code></td><td>an np.ndarray float32 [N,1] array where N is the number of points in the graph.</td></tr><tr><td><code>x_label</code></td><td>(optional) - the x label for the graph</td></tr><tr><td><code>y_label</code></td><td>(optional) - the y label for the graph</td></tr><tr><td><code>x_range</code></td><td>(optional) - controlling the ticks on the x axis by supplying a minimum and maximum value</td></tr><tr><td><code>legend</code></td><td>(optional) - a legend for distinguishing between different lines plotted in the same  graph</td></tr></tbody></table>

## Examples

#### Basic Usage

```python
from code_loader.contract.visualizer_classes import LeapGraph
from code_loader.contract.enums import LeapDataType
import numpy as np
...

@tensorleap_custom_visualizer("diff", LeapDataType.Graph)
def diff_per_channel_visualizer(prediction: np.ndarray, ground_truth: np.array) -> LeapGraph:
    diff = pred - ground_truth
    return LeapGraph(diff)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/python-api/code_loader/visualizer_classes/leapgraph.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
